
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>损失函数减肥用，神经网络调权重（深度学习入门系列之六） / iVAN</title>

    <meta name="description" content="损失函数减肥用，神经网络调权重（深度学习入门系列之六） 更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud 系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一) 人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二) 神经网络不胜语,M-P模型似可寻(深度学习入门系列之三) &quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四) Hello World感知机,懂你我心才安息 (深度学 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">损失函数减肥用，神经网络调权重（深度学习入门系列之六）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>更多深度文章，请关注云计算频道：https://yq.aliyun.com/cloud<br /></b></p>
<hr>
<br /><b>系列文章：</b></p>
<p>一入侯门“深”似海，深度学习深几许（深度学习入门系列之一）</p>
<p>人工“碳”索意犹尽，智能“硅”来未可知（深度学习入门系列之二）</p>
<p>神经网络不胜语，M-P模型似可寻（深度学习入门系列之三）</p>
<p>“机器学习”三重门，“中庸之道”趋若人（深度学习入门系列之四）</p>
<p>Hello World感知机，懂你我心才安息 (深度学习入门系列之五)</p>
<p> </p>
<p>在上一讲中，我们提到，由于感知机不能解决“异或”问题，明斯基并无恶意却把“人工智能”打入“冷宫”二十载。而解决“异或”问题的关键在于，是否能解决非线性可分问题。那么，如何来解决这个问题呢？简单来说，就是使用更加复杂的网络，也就说利用多层前馈网络。在本讲，我们将详细讨论这个问题。</p>
<h2>6.1 多层网络搞定“异或”问题</h2>
<p>现在我们都知道，深度学习是一个包括很多隐含层的复杂网络结构。感知机之所以当年搞不定“非线性可分”问题，也是因为相比于深度学习这个“老江湖”，是因为它“too young，too simple（太年轻，太简单）”。当时，“感知机”刚刚诞生不久，如初生之婴儿，你也很难期望这么一个襁褓之娃复杂起来。</p>
<p>如前文所述，想解决“异或”问题，就需要让网络复杂起来。这是因为，复杂的网络，表征能力就比较强[1]。按照这个思路，我们在输入层和输出层之间，添加一层神经元，将其称之为隐含层（hidden layer，亦有简称为“隐层”）。这样一来，隐含层和输出层中的神经元都拥有激活函数。假设各个神经元的阈值均为0.5，权值如图6-1所示，就实现了“异或”功能。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzJhMWI2ZWMxMzE2MGNjNTEwNTk0NDIyM2U2MzdjYTk4YzA4ZmYzNmMuanBlZw==.jpg"></p>
<p>图6-1 可解决“异或”问题的两层感知机</p>
<p>下面我们来详述这个实现流程。假设在如图6-1-a所示的神经元（即实心圆）的激活函数，依然是阶跃函数（即sgn函数），那么它的输出规则很非常简单：当<i>x</i>&gt;0时，<i>f(x)</i>输出为1，否则输出0。</p>
<p>那么，对于<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>相同（即均为1）时，对于在隐含层的神经元1有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzU5YjE1ZDYzYWFhYzU4Y2IwN2I4NzM2NzQ2NzAyNTZhMGRkYjExYTIuanBlZw==.jpg"></p>
<p>类似地，对于在隐含层的神经元2有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2Q5OWNjOTgzZGY2NjRhNGUwOTE5ODM2MmQ3MmYzZTJhZGIwOWY1MzYuanBlZw==.jpg"></p>
<p>然后，对于输出层的输出神经元3而言，这时<i>f</i><sub>1</sub>和<i>f</i><sub>2</sub>是它的输入，于是有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2M0MTBiMGUxMGI4NjNjZmZlYjQyNDE0ZGM5OTJiNDU5OWRiNDAwNjUuanBlZw==.jpg"></p>
<p>也就是说，<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>同为1时，输出为0。</p>
<p>那么对于<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>不相同（比如说，<i>x</i><sub>1</sub>为1时，<i> x</i><sub>2</sub>为0）时，对于在隐含层的神经元1有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzM0ZGI4OGExNzg4NTdmOTliY2RlMGU0YmIzY2U4MDllOTZmZjFiZTQuanBlZw==.jpg"></p>
<p>类似地，对于在隐含层的神经元2有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzc2ZDFmOGQ1OWI3ZWZmYjJiMGYwNjZlZDZmNjcwYzdiNzI5OWY3NDkuanBlZw==.jpg"></p>
<p>然后，对于输出层的神经元3而言，<i>f</i><sub>1</sub>和<i>f</i><sub>2</sub>是它的输入，于是有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzhmOGI0NGExOGY2YmIyOGU3YzZiMTUzNzI0ODdjNmNmMWJiY2ExOGUuanBlZw==.jpg"></p>
<p>不失一般性，由于<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>的地位是可以互换的，因此从上面分析可知，如图6-1所示的两层感知机，就可以实现“异或”功能。在这里，网络中的权值和阈值是我们事先给定的，而实际上，它们是需要神经网络自己通过反复地“试错”学习而来。</p>
<p>让我们再简单回顾一下神经网络的发展历史。1958年，弗兰克·罗森布拉特（Frank Rosenblatt）提出“感知机”（Perceptron）的概念。</p>
<p>1965年，A. G.伊瓦赫年科（Alexey Grigorevich Ivakhnenko）就提出了多层人工神经网络的设想。而这种基于多层神经网络的机器学习模型，后来被人们称为“深度学习”。</p>
<p>简单来说，所谓深度学习，就是包括很多隐含层的神经网络学习。这里的“深”即意味着“层深”（’Deep’ means many hidden layers），“网络深深深几许”呢？至少要大于3吧，多则不限，可以成百甚至上千。</p>
<p>所以，你看到了吧，如果追根溯源的话，伊瓦赫年科才是“深度学习”之父[2]，而不是现在的“深度学习”大牛杰弗里•辛顿（Geoffrey Hinton），但鉴于辛顿的杰出贡献——是他让“深度学习”重见天日、大放异彩。因此，称呼辛顿为深度学习教父（Godfather of deep learning），似乎也更为合适[3]。</p>
<p>更需要我们玩味的是，在多层神经网络概念提出4年之后的1969年，明斯基才写出来他的那本“毒苹果”之作《感知机》。也就是说，多层神经网络在提出之后，并没有受到应有的重视。</p>
<p>直到1975年（此时，距离伊瓦赫年科提出多层神经网络概念已达10年之久了），感知机的“异或难题”才被理论界彻底解决。由此，见微知著可以看到，科学技术的发展，从而都不是线性地一蹴而就，而是呈现螺旋上升的！</p>
<p>我们现在学习这个“异或”解决方案，可能仅需要数分钟，但也是“书上一分钟，书后十年功”啊！</p>
<h2>6.2多层前馈神经网络</h2>
<p>更一般地，常见的多层神经网络如图6-2所示。在这种结构中，每一层神经元仅仅与下一层的神经元全连接。而在同一层，神经元彼此不连接，而且跨层的神经元，彼此间也不相连。这种被简化的神经网络结构，被称之为“多层前馈神经网络（multi-layer feedforward neural networks）”。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NhNWIwYjI3ZmNjNGQ2NmZlNDA5OTg2YjAzYjk5ODBlM2I4ZDhjYjQuanBlZw==.jpg"></p>
<p>图6-2 多层前馈神经网络结构示意图</p>
<p>在多层前馈神经网络中，输入层神经元主要用于接收外加的输入信息，在隐含层和输出层中，都有内置的激活函数，可对输入信号进行加工处理，最终的结果，由输出层“呈现”出来。</p>
<p>这里需要说明的是，神经元中的激活函数，并不限于我们前面提到的阶跃函数、Sigmod函数，还可以是现在深度学习常用的ReLU（Rectified Linear Unit）和sofmax等。</p>
<p>简单来说，神经网络的学习过程，就是通过根据训练数据，来调整神经元之间的连接权值（connection weight）以及每个功能神经元的输出阈值。换言之，神经网络需要学习的东西，就蕴含在连接权值和阈值之中。</p>
<p>拟人化来说，对于识别某个对象来说，神经网络中的连接权值和阈值，就是它关于这个对象的“记忆（memory）”啊！</p>
<p>我们知道，大脑对于事物和概念的记忆，不是存储在某个单一的地点，而是像分布式地存在于一个巨大的神经元网络之中。</p>
<p>硅谷投资人王川先生认为，分布式表征（Distributed Representation），是人工神经网络研究的一个核心思想。那什么是分布式表征呢？简单来说，就是当我们表达一个概念时，神经元和概念之间不是一对一对应映射（map）存储的，它们之间的关系是多对多。具体而言，就是一个概念可以用多个神经元共同定义表达，同时一个神经元也可以参与多个不同概念的表达，只不过所占的权重不同罢了。</p>
<p>举例来说，对于“小红汽车”这个概念，如果用分布式特征地表达，那么就可能是一个神经元代表大小（形状：小），一个神经元代表颜色（颜色：红），还有一个神经元代表车的类别（类别：汽车）。只有当这三个神经元同时被激活时，就可以比较准确地描述我们要表达的物体。</p>
<p>分布式表征表示有很多优点。其中最重要的一点，莫过于当部分神经元发生故障时，信息的表达不会出现覆灭性的破坏。比如，我们常在影视作品中看到这样的场景，仇人相见分外眼红，一人（A）发狠地说，“你化成灰，我都认识你（B）！”这里并不是说B真的“化成灰”了，而是说，虽然时过境迁，物是人非，当事人B外表也变了很多（对于识别人A来说，B在其大脑中的信息存储是残缺的），但没有关系，只要B的部分核心特征还在，那A还是能够把B认得清清楚楚、真真切切！人类的大脑还是真的厉害啊！（现在这句话，也被好端端地被玩坏了，见图6-3）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzcxYTY1NmQwODU1ZGZmNjJmYjdkZTNhZGEwMjZiYTZhNjA4ODExZjQuanBlZw==.jpg"></p>
<p>图6-3  核心特征不丢失:化成灰我都认识你</p>
<p>前文提到，对于相对复杂的前馈神经网络，其各个神经元之间的链接权值和其内部的阈值，是整个神经网络的灵魂所在，它需要通过反复训练，方可得到合适的值。而训练的抓手，就是实际输出值和预期输出值之间存在着“落差”（你可以称之为“误差”）。</p>
<p>下面我们就先用一个小故事，来说明如何利用“落差”来反向调节网络参数的。</p>
<h2>6.3现实很丰满，理想很骨感</h2>
<p>说到理想和现实的“落差”时，人们常用这么一句话来表达：“理想很丰满，现实很骨感。”</p>
<p>事实上，有时候，这句话反着说，也是成立的：“现实很丰满，理想很骨感”。你可能猜到了，我说的是“减肥”这件事。</p>
<p>有人开玩笑说，男人有两大烦恼：一是把别人的肚子搞大了，二是把自己的肚子搞大了。还记得六七年前我在美国读书时，由于美帝的物质条件太好，肉食非常便宜，所以一不小心，糟了！我把自己的肚子搞大了。</p>
<p>等到临近回国的前三个月，一次无意站在体重秤上，我“惊喜”地发现，我有了——体重居然飙到可怕的200磅！</p>
<p>这次真的把自己都吓到了，这该如何是好？有个古诗改编的段子，很能体现我当时的“窘境”：</p>
<p>瘦小离家老胖回，乡音无改肥肉堆。</p>
<p>儿童相见不相识，笑问胖纸你是谁？</p>
<p>痛定思痛，我决定减肥（说好听点，是健身！）。</p>
<p>那该如何减（健）呢？其实就一个六字秘诀：“迈开腿，管住嘴！”</p>
<p>从那天起，我每天从住处到巴哈伊教神庙 (Baha'i House of Worship)两个来回，大概10公里的有氧长跑，几乎雷打不动。你看那，蓝蓝的天空，青青的草坪，幽静的小路上，总会有个胖纸正在挥汗如雨，汗流浃背，用不停止的脚步，来为过去的贪吃“赎罪”。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzg1NzliYjczOTVhMmU1MjJjZDljMWViY2Q1ZmY3MzNiYTE1ZmU5NDYuanBlZw==.jpg"></p>
<p>图 6-4 损失函数？减重功能！</p>
<p>现在回想起来，我挺佩服自己那会的毅力。三个月下来，我减下来近50磅！</p>
<p>在踏上返回北京航班的前一个小时，我静静地坐在租住屋里，模仿那首《再别康桥》，在自己的博客上，用两句话总结了我的美国之旅：</p>
<p>“轻轻的我走了,</p>
<p>正如我轻轻的来;</p>
<p>我挥一挥手,</p>
<p>不带走一两肥肉。”</p>
<p>或许你会疑惑，咦，我们正在学习神经网络咧，你吹这段过往的牛逼，是准备改行给我们推销减肥药吗？</p>
<p>哈哈，当然不是！</p>
<p>因为这段往事，让我想起了今天的主题“误差逆传播算法”！</p>
<p>这又哪跟哪啊？</p>
<p>别急，且听我慢慢道来。</p>
<p>我们知道，在机器学习中的“有监督学习”算法里，在假设空间F中，构造一个决策函数<i>f</i>，对于给定的输入<i>X</i>，由<i>f(X)</i>给出相应的输出<i>Y</i>，这个实际输出值<i>Y</i>和原先预期值<i>Y’</i>可能不一致。于是，我们需要定义一个损失函数（loss function），也有人称之为代价函数（cost function）来度量这二者之间的“落差”程度。这个损失函数通常记作<i>L(Y,Y‘)= L(Y, f(X))</i>，为了方便起见，这个函数的值为非负数（请注意：在这里我们大写Y和Y’，分别表示的是一个输出值向量和期望值向量，它们分别包括多个不同对象的实际输出值和期望值）。</p>
<p>常见的损失函数有如下3类：</p>
<p>（1）0-1损失函数（0-1 loss function）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzZmNDJmNDdiODRhNWIyNDcxZTU0NzBiNjkyZjc1MGM1OTIyYWEwYzMuanBlZw==.jpg"></p>
<p>（2）绝对损失函数（absolute loss function）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzgwNTM0Y2M5Y2M3MWI0MDcwMWQ4NGE4ZmJhNDllYjc2M2MzN2IyNzkuanBlZw==.jpg"></p>
<p>（3）平方损失函数（quadratic loss function）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2I5YWIxOTgxMWI5Njc0MDFmNmYyNjFlNWMxYmM0YWI5YjE5YTUwZTguanBlZw==.jpg"></p>
<p>损失函数值越小，说明实际输出和预期输出的差值就越小，也就说明我们构建的模型越好。</p>
<p>对于第一类损失函数，用我自身减肥的例子很容易解释。就是减肥目标达到没？达到了，输出为0（没有落差嘛），没有达到输出1（减肥尚未成功，胖纸还需努力！）</p>
<p>对于第二类损失函数就更具体了。当前体重秤上读数和减肥目标的差值，这个差值有可能为正，但还有可能为负值，比如说，减肥目标为150磅，但一不小心减肥过猛，减到140磅，这是值就是“-10”磅，为了避免这样的正负值干扰，干脆就取一个绝对值好了。</p>
<p>对于第三类损失函数，类似于第二类。同样达到了避免正负值干扰，但是为了计算方便（主要是为了求导），通常还会在前面加一个“1/2”，这样一求导，指数上的“2”和“1/2”就可以相乘为“1”了：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzIwZTgwNTViOGM0NDgxMWE2M2IzMjY0ZmNiNGY4MTJiOGVmZTQwNTUuanBlZw==.jpg"></p>
<p>当然，为了计算方面，还可以用对数损失函数（logarithmic loss function）。这样做的目的，主要是便于使用最大似然估计的方法来求极值。一句话，咋样方便咋样来！</p>
<p>或许你会问，有了这些损失函数？有啥子用呢？当然有用了！因为可以用它反向配置网络中的权值（weight），让损失（loss）最小啊。</p>
<p>我们都知道，神经网络学习的本质，其实就是利用“损失函数（loss function）”，来调节网络中的权重（weight）。而“减肥”的英文是“weight loss”，所以你看，我用自身减肥的案例来讲这个“损失函数”，是不是很应景啊？</p>
<p>或许你又会说，就算应景，那神经网络的权值，到底该咋个调法咧？</p>
<p>总体来讲，有两大类方法比较好使。第一种方法就是“误差反向传播（Error Back propagation，简称BP）”。简单说来，就是首先随机设定初值，然后计算当前网络的输出，然后根据网络输出与预期输出之间的差值，采用迭代的算法，反方向地去改变前面各层的参数，直至网络收敛稳定。</p>
<p>这个例子说起来很抽象，我们还是用减肥的例子感性认识一下。比如说，影响减肥的两个主要因素是“运动”和“饮食”，但它们在减肥历程中的权值，并不了然。然后，如果我减肥目标是150磅，而体重秤上给出实际值是180磅，这个30磅的落差，反过来调整我“运动”和“饮食”在减肥过程中的权值（是多运动呢，还是多吃点低卡食物呢？）。</p>
<p>这个BP算法，的确大名鼎鼎。它最早是由Geoffrey Hinton 和 David Rumelhart等人1986年在《Nature》（自然）杂志上发表的论文：“Learning Representations by Back-propagating errors”中提出来的。该论文首次系统而简洁地阐述了反向传播算法在神经网络模型上的应用。</p>
<p>BP反向传播算法非常好使，它直接把纠错的运算量，降低到只和神经元数目本身成正比的程度。现在，我们可以回答上一讲中提出的问答了，是哪位“王子”把人工智能这位“白雪公主”吻醒的了。是的，没错，就是当前的这位“深度学习”教父杰弗里•辛顿（Geoffrey Hinton）！</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzg3NGEwNzhlZDc3YjBkZjI1NmJhODQxMTExMzZmOGRhNzExMjBkNzcuanBlZw==.jpg"></p>
<p>图 6-5 “人工智能”白马王子：杰弗里•辛顿</p>
<p>BP算法非常经典，在很多领域都有着经典的应用，当时它的火爆程度在绝不输给现在的“深度学习”。但后来大家发现，实际用起来它还是有些问题。比如说，在一个层数较多网络中，当它的残差反向传播到最前面的层（即输入层），其影响已经变得非常之小，甚至出现梯度扩散（gradient-diffusion），严重影响训练精度。</p>
<p>其实，这也是容易理解的。因为在“信息论”中有个信息逐层缺失的说法，就是说信息在逐层处理时，信息量是不断减少的。例如，处理A信息而得到B，那么B所带的信息量一定是小于A的。这个说法，再往深层次的探寻，那就是信息熵的概念了。推荐读者阅读一部影响我世界观的著作《熵：一种新的世界观》[5]。</p>
<p>根据热力学第二定律我们知道，能量虽然可以转化，但是无法100%利用。在转化过程中，必然会有一部分能量会被浪费掉。这部分无效的能量，就是“熵”。把“熵”的概念，迁移到信息理论，它就表示“无序的程度”。</p>
<p>按照阮一峰先生的解读，当一种形式的"有序化（即信息）"，转化为另一种形式的"有序化"，必然伴随产生某种程度上的"无序化（即熵）"[6]。依据这个理论，当神经网络层数较多时（比如说大于7层），BP反向传播算法中“误差信息”，就会慢慢“消磨殆尽”，渐渐全部变成无序的“熵”，因此就无法指导神经网络的参数调整了。</p>
<p>再后来，第二类改进方法就孕育而生了。它就是当前主流的方法，也就是“深度学习”常用的“逐层初始化”(layer-wise pre-training)训练机制[7]，不同于BP的“从后至前”的训练参数方法，“深度学习”采取的是一种从“从前至后”的逐层训练方法。这是后话，我们回头再表。</p>
<h2>6.4 小结</h2>
<p>下面我们小结一下本章的主要知识点。首先，我们讲解了如何利用多层神经网络搞定“异或”问题的方法，然后我们用“减肥”的案例，讲解了多层前馈神经网络和损失函数的概念。</p>
<p>经典是永恒的，永远值得品味。在下一讲中，我们将用图文并茂的方式，详细讲解BP算法和梯度递减的概念，特别是这个“梯度递减”概念，它还会深深影响“深度学习”算法。请你关注。</p>
<h2>6.5 请你思考</h2>
<p>通过本讲的学习，请你思考如下问题：</p>
<p>（1）著名科技哲学家詹姆斯·卡斯在其著作《有限与无限的游戏》[8]中指出，世界上有两种类型的“游戏”：“有限的游戏”和“无限的游戏”。有限游戏的目的在于，赢得胜利；而无限的游戏，却旨在让游戏永远进行下去。从神经网络发展的起起落落中，你觉得“人工智能”的发展，是有限的游戏呢？还是无限的？为啥？</p>
<p>（2）杰弗里•辛顿先后提出的BP算法和深度学习算法，它们之间除了训练参数的方法有不同之外，还有什么本质上的不同呢？</p>
<h2> 【参考文献】</h2>
<p>[1] 周志华.机器学习.清华大学出版社.2016.2</p>
<p>[2] 李开复；王咏刚. 人工智能. 文化发展出版社. 2017.1</p>
<p>[3] Anna Tremonti. CBC. Deep Learning Godfather says machines learn like toddlers.2015.5</p>
<p>[4] Williams D, Hinton G. Learning representations by back-propagating errors[J]. Nature, 1986, 323(6088): 533-538.</p>
<p>[5]  [美] 杰里米·里夫金, 特德·霍华德. 熵：一种新的世界观. 上海译文出版社. 1987.2</p>
<p>[6] 阮一峰.<a href="http://www.ruanyifeng.com/blog/2013/04/entropy.html" rel="external nofollow noreferrer"> 熵的社会学意义</a>. 2013.4</p>
<p>[7] Hinton G E, Osindero S, Teh Y W. A fast learning algorithm for deep belief nets[J]. Neural computation, 2006, 18(7): 1527-1554.</p>
<p>[8] 詹姆斯·卡斯. 有限与无限的游戏.电子工业出版社. 2013.10</p>
<p> </p>
<p>相关文章：</p>
<p>山重水复疑无路，最快下降问梯度（深度学习入门系列之七）</p>
<p>BP算法双向传，链式求导最缠绵（深度学习入门系列之八）</p>
<p>全面连接困何处，卷积网络见解深（深度学习入门系列之九）</p>
<p>卷地风来忽吹散，积得飘零美如画（深度学习入门系列之十）</p>
<p>局部连接来减参，权值共享肩并肩（深度学习入门系列之十一）</p>
<p>文章作者：张玉宏，著有《<a href="http://product.dangdang.com/24048575.html" rel="external nofollow noreferrer">品味大数据</a>》一书。</p>
<p>联系邮件：zhangyuhong001@gmail.com</p>
<p>审校：我是主题曲哥哥、阿福。</p>
<p><b>（未完待续）</b></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 20:56:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%b7%b1%e5%ba%a6%e5%ad%a6%e4%b9%a0/" title="深度学习">深度学习</a>, <a href="https://www.iamivan.net/tag/%e7%a5%9e%e7%bb%8f%e7%bd%91%e7%bb%9c/" title="神经网络">神经网络</a>, <a href="https://www.iamivan.net/tag/%e4%ba%ba%e5%b7%a5%e6%99%ba%e8%83%bd/" title="人工智能">人工智能</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="大数据">大数据</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/%e5%93%81%e5%91%b3%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="品味大数据">品味大数据</a>, <a href="https://www.iamivan.net/tag/%e5%bc%a0%e7%8e%89%e5%ae%8f/" title="张玉宏">张玉宏</a>, <a href="https://www.iamivan.net/tag/%e6%8d%9f%e5%a4%b1%e5%87%bd%e6%95%b0/" title="损失函数">损失函数</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>损失函数减肥用，神经网络调权重（深度学习入门系列之六）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRNBBaM.html" rel="bookmark">神经网络不胜语， M-P模型似可寻（深度学习入门系列之三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一) 人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二)   &quot;那些在个人设备里,谦谦卑卑地为我们哼着歌曲的数字仆人,总有一天会成为我们的霸主!&quot; --A.I. winter   在前面的小节中,我们大致了解了机器学习的形式化定义和神经网络的概念,在本小节中,我们将相对深入地探讨一下神经网络中的神经元模型以及深度学习常常用到的激活函数及卷积函数. 3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg3Nq8M.html" rel="bookmark">Hello World感知机，懂你我心才安息 &lpar;深度学习入门系列之五&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud 系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一) 人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二) 神经网络不胜语,M-P模型似可寻(深度学习入门系列之三) &quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四) 原文再续,书接上回. 5.1 网之初,感知机 我们知道,&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqA7EaM.html" rel="bookmark">全面连接困何处，卷积网络见解深（深度学习入门系列之九）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一) 人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二) 神经网络不胜语,M-P模型似可寻(深度学习入门系列之三) &quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四) Hello World感知机,懂你我心才安息 (深度学习入门系列之五) 损失函数减肥用,神经网络调权重(深度学习入门系列之六) 山重水复疑无路,最快下降			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7J5Jp.html" rel="bookmark">LSTM长短记，长序依赖可追忆（深度学习入门系列之十四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章一入侯门&quot;深&quot;似海,深度学习深几许(入门系列之一)人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二)神经网络不胜语, M-P模型似可寻(深度学习入门系列之三)&quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四)Hello World感知机,懂你我心才安息(深度学习入门系列之五)损失函数减肥用,神经网络调权重(深度学习入门系列之六)山重水复疑无路,最快下降问梯度(深度学习入门系列			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqnk8b.html" rel="bookmark">一入侯门&OpenCurlyDoubleQuote;深&rdquo;似海，深度学习深几许（深度学习入门系列之一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud  [导言]目前人工智能非常火爆,而深度学习则是引领这一火爆现场的&quot;火箭&quot;.于是,有关&quot;深度学习&quot;的论文.书籍和网络博客汗牛充栋,但大多数这类文章都具备&quot;高不成低不就&quot;的特征.对于高手来说,自然是没有问题,他们本身已经具备非常&quot;深度&quot;的学习能力,如果他们想学习有关深度学习的技术,直接找来最新的研究论文阅读就好了.但是,对于低手(初学者)而言,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQGAVz.html" rel="bookmark">BP算法双向传，链式求导最缠绵（深度学习入门系列之八）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多深度文章,请关注:https://yq.aliyun.com/cloud 系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一)人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二)神经网络不胜语,M-P模型似可寻(深度学习入门系列之三)&quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四)Hello World感知机,懂你我心才安息 (深度学习入门系列之五)损失函数减肥			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQnR8p.html" rel="bookmark">山重水复疑无路，最快下降问梯度（深度学习入门系列之七）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多深度文章,请关注:https://yq.aliyun.com/cloud 系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一)人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二)神经网络不胜语,M-P模型似可寻(深度学习入门系列之三)&quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四)Hello World感知机,懂你我心才安息 (深度学习入门系列之五)损失函数减肥			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmXB8z.html" rel="bookmark">激活引入非线性，池化预防过拟合（深度学习入门系列之十二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一) 人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二) 神经网络不胜语,M-P模型似可寻(深度学习入门系列之三) &quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四) Hello World感知机,懂你我心才安息 (深度学习入门系列之五) 损失函数减肥用,神经网络调权重(深度学习入门系列之六) 山重水复疑无路,最快下降			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPVZ8p.html" rel="bookmark">人工&OpenCurlyDoubleQuote;碳&rdquo;索意犹尽，智能&OpenCurlyDoubleQuote;硅&rdquo;来未可知（深度学习入门系列之二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章:一入侯门&quot;深&quot;似海,深度学习深几许(入门系列之一) 在前面的小节中,我们仅仅泛泛而谈了机器学习.深度学习等概念,在这一小节,我们将给出它的更加准确的形式化描述. 我们经常听到人工智能如何如何?深度学习怎样怎样?那么它们之间有什么关系呢?在本小节,我们首先从宏观上谈谈人工智能的&quot;江湖定位&quot;和深度学习的归属.然后再在微观上聊聊机器学习的数学本质是什么?以及我们为什么要用神经网络? 2.1 人工智能的&quot;江湖定位&quot; 宏观上来看, 人类科学和技术			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBR7kb.html" rel="bookmark" class="title">建一个XMLHttpRequest对象池</a>
					<div>
						request|xml|xmlhttprequest|对象 在ajax应用中,通常一个页面要同时发送多个请求,如果只有一个XMLHttpRequest对象,前面的请求还未完成,后面的就会把前面的覆盖掉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKO1Ob.html" rel="bookmark" class="title">如何PHP的图形函数中显示汉字。</a>
					<div>
						函数|汉字|图形|显示 &lt;?php/****************************** 如何在PHP图形函数中显示汉字,大家已经问了很久了,但一直没有结果.终于在参考另一篇文章后,我试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx8wBM.html" rel="bookmark" class="title">良好的404页面应该遵循的理念</a>
					<div>
						网页制作Webjx文章简介:网站404错误页面中的用户体验. 1. 什么是404 404是一个 http 错误代码,即请求的网页不存在.代码404的第一个&quot;4&quot;代表客户端的错误,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp54onM.html" rel="bookmark" class="title">做个按钮控制图片缓冲切换的效果&lpar;带模糊滤镜&rpar;</a>
					<div>
						按钮|控制|滤镜 一个带缓冲的图片切换的效果,按钮控制,加了模糊滤镜,提升速度感.源文件已附上.下面是代码: stop(); /////也打上自己的名字-_-,绝命时刻2006年11月18日///// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgxe3p.html" rel="bookmark" class="title">64位Windows Server 2008 R2的远程桌面会话被中断</a>
					<div>
						Win_Server2008R2_64:远程桌面授权过期,导致的远程会话被中断,问题解决方法 有两台windows Server2008R2_64,大概有一个月没有连接了,今天研发说有更新,我就正常的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze47RNp.html" rel="bookmark" class="title">memcached（十）simple-spring-memcached</a>
					<div>
						简介 simple-spring-memcached是spring和xmemcached的集成使用.用注解的方式使用缓存. 官方地址 http://code.google.com/p/simple-s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2nXJb.html" rel="bookmark" class="title">X3D实战基础讲座之七</a>
					<div>
						第七讲 光源处理 在X3D场景空间中,可以使用点光源节点(PointLight).平行光源节点(DirectionalLight)和聚光性光源节点(SpotLight)来处理造型物体的光照明亮程度.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62LNLM.html" rel="bookmark" class="title">android保存图片到SD卡并以时间命名</a>
					<div>
						 private void storeInSD(Bitmap bitmap1) { File file = new File(FILE_DIR); if (!file.exists()) { file ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7r7Db.html" rel="bookmark" class="title">导航设计中的信息结构</a>
					<div>
						在进入今天的主题之前,我们先来探讨导航的重要性,并分析一下门户网站中导航的表现. 导航直接影响到公司的财政收入 导航会给我们带来哪些好处?导航不光只是提供信息获取的途径,它的设计优劣会直接影响到整个公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPdxrz.html" rel="bookmark" class="title">家用喷墨打印机常见故障</a>
					<div>
						喷墨打印机终究是机器,而机器应用当中就不可避免会遇到麻烦.这些麻烦或者来自于应用,或者来源于毛病.分之,这些麻烦的最终结果都是让照片打印无法正常继续.为了让大家在照片打印时更好的处理这些问题,保证打印 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kaR5z.html" rel="bookmark" class="title">Word2010如何给图片添加立体效果？</a>
					<div>
						  1.打开需要编辑修改的Word文档,点击工具栏的&quot;插入&quot;然后插入图片 2.点击工具栏的&quot;图片效果&quot;我们就可以对图片设定各类的效果. 3.在图片效果里选择&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8862b.html" rel="bookmark" class="title">如何把BANNER做得传情达意</a>
					<div>
						  编者按:初入职场的设计师,可能每天都要做大量banner,工作多了,创意跟不上怎么办?其实创作banner也有规律可循,网易的同学就用大量案例 + 多个角度分享了他的经验,是一篇不可多得的经典文章 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z724odp.html" rel="bookmark" class="title">BIOS设置项目英语详解</a>
					<div>
						  Time/System Time 时间/系统时间 Date/System Date 日期/系统日期 Level 2 Cache 二级缓存 System Memory 系统内存 Video Cont ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaZWAz.html" rel="bookmark" class="title">文本向量化初学者指南</a>
					<div>
						更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud 在自然语言处理(NLP)诞生之初,需要将文本转换成机器可以理解的东西.换句话说,就是将文本转换为有意义的数字向量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6N0wYM.html" rel="bookmark" class="title">mfc窗口分割后的通信问题</a>
					<div>
						问题描述 mfc窗口分割后的通信问题 VS2010环境下编写的,把视图分割成了上下两个窗口,都是CFormView类的,上面的窗口只有一个teechart控件,想要实现的功能是点击下面窗口的一个按钮在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6dwqz.html" rel="bookmark" class="title">hdu3635 Dragon Balls&lpar;带权并查集&rpar;</a>
					<div>
						/* 题意:有N个城市, 每一个城市都有一个龙珠(编号与城市的编号相同),有两个操作 T A ,B 将标号为A龙珠所在城市的所有的龙珠移动到B龙珠所在城市中! 思路:并查集 (压缩路径的时候将龙珠移动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwoL4M.html" rel="bookmark" class="title">接口-想知道现在国内的HIS一般都用什么数据库</a>
					<div>
						问题描述 想知道现在国内的HIS一般都用什么数据库 现在的his一般都用的什么样数据存储方式啊?都用的什么数据库?对于医疗设备都设置了怎样的接口? 解决方案 sql server mysql orac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx2l5b.html" rel="bookmark" class="title">定制textField</a>
					<div>
						// // HYBTextField.h // CloudShopping // // Created by sixiaobo on 14-7-10. // Copyright (c) 2014年 c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Q7Ob.html" rel="bookmark" class="title">powermanager-Android第三方App如何调用PowerManager&period;gotosleep&lpar;&rpar;实现睡眠。</a>
					<div>
						问题描述 Android第三方App如何调用PowerManager.gotosleep()实现睡眠. 如题,Android第三方应用调用PowerManager.gotosleep()是总是出错,权 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeYP6b.html" rel="bookmark" class="title">截取-求一正则表达式 关于js方面的</a>
					<div>
						问题描述 求一正则表达式 关于js方面的 求一正则表达式 关于js方面的 就是判断数字为1-360之间 可以输入小数点 但是像300.000这样的不能输入 小数点后面截取两位 359.99这样是可以输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKOd0z.html" rel="bookmark" class="title">redis存在线客户端对象列表的方式合不合理？</a>
					<div>
						问题描述 redis存在线客户端对象列表的方式合不合理? 使用redis存一个在线客户端列表的方式好不?因为想实现分布式时可以在另一台电脑上取到相应客户端 为了保持同步,是不是对任一个客户端的任一属性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWD35z.html" rel="bookmark" class="title">linux基础之uboot load address、entry point、 bootm address以及kernel运行地址的意义及联系</a>
					<div>
						按各地址起作用的顺序,uboot引导linux内核启动涉及到以下地址: load address: entry point: 这两个地址是mkimage时指定的 bootm address:bootm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqd2Vp.html" rel="bookmark" class="title">ubuntu14&period;04 编译安装highpoint rocketraid 2720驱动</a>
					<div>
						highpoint官方只有ubuntu12.10驱动,对于ubuntu14.04或者12.04,需要手工编译安装驱动. 基本步骤: 1.下载rocketraid 2720驱动源代码 2.在一台装有ub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12KKxp.html" rel="bookmark" class="title">名城扬州网总监刘明：移动时代仍信仰内容为王</a>
					<div>
						编者按:2014中国互联网创业者大会(zz.comsenz.com)将于5月10日在北京国际会议中心举行.在大会召开前夕,Discuz!.腾讯云联合DoNews等多家机构和媒体共同推出2014社区龙虎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1j5Wb.html" rel="bookmark" class="title">Bootstrap自动适应PC、平板、手机的Bootstrap栅格系统&lowbar;javascript技巧</a>
					<div>
						栅格系统英文为&quot;grid systems&quot;,也有人翻译为&quot;网格系统&quot;,运用固定的格子设计版面布局,其风格工整简洁,在二战后大受欢迎,已成为今日出版物设计的主流风 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NZ1dp.html" rel="bookmark" class="title">Visual InterDev常见问题解答（一）</a>
					<div>
						1.FrontPage和Visual InterDev有何差异?新版本有什么变化吗?2.Visual InterDev和Visual Basic如何实现共同开发?3.使用Visual InterDev ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVgkBz.html" rel="bookmark" class="title">quartz2&period;1&period;5 调用 scheduler&period;start&lpar;&rpar;方法时报异常</a>
					<div>
						问题描述 quartz2.1.5 调用 scheduler.start()方法时报这样一个异常:严重: An error occurred while scanning for the next tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8N4PBb.html" rel="bookmark" class="title">？？如何記錄用戶登錄的信息</a>
					<div>
						问题描述 我在一個網站加入了用戶註冊的功能,怎么樣才能實現:顯示用戶的登錄信息,比如用戶的IP 在線人數等還有如果用戶斷開連接,我又怎么才能知道呢?請高手給個提示吧,有代碼更好,謝謝了 解决方案 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgR8ez.html" rel="bookmark" class="title">如何做到在物理打印机上也无边距打印</a>
					<div>
						问题描述 使用e.Graphics.DrawLine(NewPen(Color.Black),0,yPos,e.PageBounds.Right,yPos)打印一条线,在xps虚拟打印机中,线是从最左 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgP0K3p.html" rel="bookmark" class="title">自媒体们想好发展的后路了吗？</a>
					<div>
						国内自媒体究竟是朝阳还是已经进入暮年,自媒体联盟名单据说还在不断刷新,众多人都在加入这个方队,仍旧难以吸引媒体行业的目光,就现在而言,再分析也看不到长远的http://www.aliyun.com/z ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
